From 6ec810fe6a5dbde6f4e21e19092582c0ad9c0fdf Mon Sep 17 00:00:00 2001
From: Harald Pfeiffer <coding@lirion.net>
Date: Wed, 25 Nov 2015 19:57:25 +0100
Subject: Initial commit

---
 Makefile          |  36 +++++++++++
 README.md         |  19 ++++++
 default/infinoted |  14 ++++
 init.d/infinoted  | 186 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 255 insertions(+)
 create mode 100644 Makefile
 create mode 100644 README.md
 create mode 100644 default/infinoted
 create mode 100755 init.d/infinoted

diff --git a/Makefile b/Makefile
new file mode 100644
index 0000000..3528623
--- /dev/null
+++ b/Makefile
@@ -0,0 +1,36 @@
+VERSION	= 3.81
+
+all:	help
+
+install: init defaults remark
+
+init: has_init
+	@cp -v init.d/infinoted /etc/init.d/
+
+default:
+	@cp -v default/infinoted /etc/default/
+
+has_init:
+	@pidof inits 2>&1 >/dev/null
+
+remark:
+	@echo "You might want to add the script to runlevels after testing. LSB compliant header existing."
+
+uninstall:
+	@rm -v /etc/init.d/infinoted /etc/default/infinoted
+
+.PHONY: help
+
+help:
+	@echo
+	@echo "Syntax  : MAKE [target]"
+	@echo
+	@echo "Targets : help\t\t- Displays this help."
+	@echo "          install\t- Installs script and compressed manpage."
+	@echo "          init\t\t- Installs only the SysVinit script."
+	@echo "          default\t- Only installs the file containing the application defaults."
+	@echo "          uninstall\t- Deletes all files from your system."
+	@echo
+	@echo "Make sure you have all necessary privileges before doing something :)"
+	@echo "As there's nothing to compile here, a \"make\" or \"make all\" will just fire up this help."
+	@echo
diff --git a/README.md b/README.md
new file mode 100644
index 0000000..3b36d58
--- /dev/null
+++ b/README.md
@@ -0,0 +1,19 @@
+# mp3dirlist
+
+This is simply a SysVinit compliant start script for [infinoted](https://gobby.github.io), a server providing real time collaborative editing using [libinfinity](http://infinote.org/).
+
+It's an hour's dirty work for now, so don't expect too much. It works, and that's what it's supposed to do. Keep an eye out for the remarks in default/infinoted, and for further
+debugging look into the init script itself.
+
+Requirements
+------------
+
+* infinoted -- look out for system packages. If your distro delivers an init script, don't mind this git repo and leave.
+* git (:
+
+Installation
+------------
+
+Just type "make help".
+
+The alternative: Copy init.d/infinoted to your SysVinit core script directory, default/infinoted to wherever your distro stores default variable scripts.
diff --git a/default/infinoted b/default/infinoted
new file mode 100644
index 0000000..a26b0b0
--- /dev/null
+++ b/default/infinoted
@@ -0,0 +1,14 @@
+# Default values to - yes, right, infinoted. This will be read by initd's infinoted
+# which was also released by me. Both files are half an hour of dirty work, don't
+# except perfection or DAU compliance.
+
+# If you enter a wrong value here, infinote will throw an error at you but continue
+# nonetheless. Be careful.
+INFINOTE_ROOT="/usr/local/share/infinoted"
+
+# The certificates. With this version we force TLS. You're better off so anyway (;
+INFINOTE_CERT="/etc/infinoted/cert.pem"
+INFINOTE_KEY="/etc/infinoted/key.pem"
+
+# The port to listen on
+INFINOTE_PORT="6663"
diff --git a/init.d/infinoted b/init.d/infinoted
new file mode 100755
index 0000000..d416d34
--- /dev/null
+++ b/init.d/infinoted
@@ -0,0 +1,186 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          infinoted
+# Required-Start:    $network $remote_fs $syslog
+# Required-Stop:     $network $remote_fs $syslog
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Launches infinoted.
+# Description:       My hovercraft is full of eels.
+### END INIT INFO
+
+# Author: Harald Pfeiffer <coding@lirion.de>
+# Version: 0.666
+# This is basically the SysVinit skeleton from Debian with
+# whatever adjustments necessary (see comment lines) for infinote.
+# Lazy work, no comments removed, loads of hubbub remaining.
+#
+# Alterations made to the skeleton mechanics and not commented below:
+# status_of_proc: So we set up a $PIDFILE and don't pass it on to
+#	status_of_proc? What's the danger in this? In infinoted's case,
+#	however, we are heavily dependent on this. Added.
+
+# Additional remarks:
+# CLI output: infinoted insists on puking its loaded plugins at you at any
+#	startup, so the LSB startup line might look a bit chaotic.
+#	Unfortunately, same as the location of the PID file, this is
+#	hardcoded. *claps*
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+# hp -- demo has a Debian package, might need to add /usr/local or whatever else here
+#	when compiling yourselves
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="Infinoted, a server for collaborative editing"
+NAME=infinoted
+DAEMON=/usr/bin/$NAME
+# hp -- We are now presenting some defaults here, will be overwritten if present in /etc/default/$NAME
+INFINOTE_ROOT="/usr/local/share/infinoted"
+INFINOTE_CERT="/etc/infinoted/cert.pem"
+INFINOTE_KEY="/etc/infinoted/key.pem"
+INFINOTE_PORT="6663"
+# hp -- infinoted is a nasty fucker with its pid file: it's hardcoded*. Whatever you pass on as -r
+#	(infinote document root) will be used for the pid file as well ):
+#	* harcoded as in: no option to change this path. Wonderful.
+#	You might of course set up the document directory before (; don't forget to adjust
+#	SCRIPTUSER below
+# hp -- Mind the major infinote release - the devs decided to put its number into the pid file name.
+#	Bleh.
+PIDFILE=$INFINOTE_ROOT/.infinoted/infinoted-0.5.pid
+SCRIPTNAME=/etc/init.d/$NAME
+# hp -- add a user to execute this. Might not want to run this as root (:
+SCRIPTUSER="infinote:infinote"
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+DAEMON_ARGS="-d -c $INFINOTE_CERT -k $INFINOTE_KEY -p $INFINOTE_PORT -r $INFINOTE_ROOT"
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	start-stop-daemon -c $SCRIPTUSER --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
+		|| return 1
+	start-stop-daemon -c $SCRIPTUSER --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
+		$DAEMON_ARGS \
+		|| return 2
+	# Add code here, if necessary, that waits for the process to be ready
+	# to handle requests from services started subsequently which depend
+	# on this one.  As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	start-stop-daemon -c $SCRIPTUSER --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Wait for children to finish too if this is a daemon that forks
+	# and if the daemon is only ever run from this initscript.
+	# If the above conditions are not satisfied then add some other code
+	# that waits for the process to drop all resources that could be
+	# needed by services started subsequently.  A last resort is to
+	# sleep for some time.
+	start-stop-daemon -c $SCRIPTUSER --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+	[ "$?" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	#rm -f $PIDFILE
+	return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+	#
+	# If the daemon can reload its configuration without
+	# restarting (for example, when it is sent a SIGHUP),
+	# then implement that here.
+	#
+	start-stop-daemon -c $SCRIPTUSER --stop --signal 1 --quiet --make-pidfile --pidfile $PIDFILE --name $NAME
+	return 0
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  status)
+	status_of_proc -p $PIDFILE "$DAEMON" "$NAME" && exit 0 || exit $?
+	;;
+  #reload|force-reload)
+	#
+	# If do_reload() is not implemented then leave this commented out
+	# and leave 'force-reload' as an alias for 'restart'.
+	#
+	#log_daemon_msg "Reloading $DESC" "$NAME"
+	#do_reload
+	#log_end_msg $?
+	#;;
+  restart|force-reload)
+	#
+	# If the "reload" option is implemented then remove the
+	# 'force-reload' alias
+	#
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+		# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
-- 
cgit v1.2.3